package com.supervision.enums;

import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.lang.Pair;

import java.util.List;

public enum RetireRoleEnum {

    sex("性别", ListUtil.list(false, Pair.of(0, "男"), Pair.of(1, "女"))),
    age("年龄", ListUtil.list(false, Pair.of(0, "年满60岁"), Pair.of(1, "未满60岁"))),
    socialSecurityType("退休类型", ListUtil.list(false, Pair.of(0, "城乡居民"), Pair.of(1, "企业职工"))),
    residentLocation("户口所在地", ListUtil.list(false, Pair.of(0, "深圳户口"), Pair.of(1, "港澳台和外籍人员"), Pair.of(2, "广东省其他地区"), Pair.of(3, "省外户口"))),
    offsiteSocialSecurityInfo("异地社保转入情况", ListUtil.list(false, Pair.of(0, "无异地社保"), Pair.of(1, "已转入"), Pair.of(2, "未转入"))),
    pensionPaymentPeriod("缴费年限", ListUtil.list(false, Pair.of(0, "实际缴费年限+视同缴费年限满15年"), Pair.of(1, "实际缴费年限+视同缴费年限未满15年")));

    private final String zhName;

    private final List<Pair<Integer, String>> answerList;

    RetireRoleEnum(String zhName, List<Pair<Integer, String>> answerList) {
        this.zhName = zhName;
        this.answerList = answerList;
    }

    public String getZhName() {
        return zhName;
    }

    public List<Pair<Integer, String>> getAnswerList() {
        return answerList;
    }
}
