package com.supervision.qanything.dto.offline;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.supervision.qanything.dto.HistoryDTO;
import com.supervision.qanything.dto.ResultWrapper;
import com.supervision.qanything.dto.SourceDTO;
import lombok.Data;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

@Data
public class ChatResult {
    private String code;

    private String msg;

    private String question;

    private String response;

    private List<List<String>> history;

    private List<SourceDocument> source_documents;

    public ResultWrapper<com.supervision.qanything.dto.ChatResult> toResultWrapper() {
        ResultWrapper<com.supervision.qanything.dto.ChatResult> resultWrapper = new ResultWrapper<>();
        resultWrapper.setMsg("200".equals(code)?"0":"500");
        resultWrapper.setMsg(msg);
        com.supervision.qanything.dto.ChatResult chatResult = new com.supervision.qanything.dto.ChatResult();
        chatResult.setQuestion(question);
        if (StrUtil.isNotEmpty(response)){
            String jsonString = StrUtil.removePrefix(response, "data: ");
            String answer = JSONUtil.parseObj(jsonString).getStr("answer");
            chatResult.setResponse(answer);
        }

        // setHistory
        if (CollUtil.isNotEmpty(history)){
            List<HistoryDTO> historyDTOS = history.stream().map(item -> {
                if (CollUtil.isNotEmpty(item)) {
                    HistoryDTO historyDTO = new HistoryDTO();
                    historyDTO.setQuestion(item.get(0));
                    if (item.size() > 1) {
                        historyDTO.setResponse(item.get(1));
                    }
                    return historyDTO;
                } else {
                    return null;
                }
            }).filter(Objects::nonNull).collect(Collectors.toList());
            chatResult.setHistory(historyDTOS);
        }

        // setSource
        if (CollUtil.isNotEmpty(source_documents)){
            List<SourceDTO> sourceDTOS = this.source_documents.stream().map(SourceDocument::toSourceDTO).collect(Collectors.toList());
            chatResult.setSource(sourceDTOS);
        }

        resultWrapper.setResult(chatResult);
        return resultWrapper;

    }
}
