package com.supervision.qanything.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONUtil;
import com.supervision.qanything.QanythingService;
import com.supervision.qanything.dto.*;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;
import java.security.NoSuchAlgorithmException;
import java.util.List;

@Service
@Slf4j
@RequiredArgsConstructor
@ConditionalOnProperty(name = "youdao.qanthing.online", havingValue = "false")
public class OfflineQanythingServiceImpl implements QanythingService {

    @Value("${youdao.qanthing.baseUrl}")
    private String BASE_URL;

    @Value("${youdao.qanthing.default_user_id:zzp}")
    private String defaultUserId;
    @Override
    public ResultWrapper<CreateKBResult> createKB(String kbName) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<String> deleteKB(String kbId) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<ChatResult> chat(String question, List<String> kbIds) {

        kbIds = CollUtil.newArrayList("KB90b7c7ca27d543eab714e746c5f6f1f0");
        Assert.notEmpty(kbIds, "kbIds不能为空");
        Assert.notEmpty(question, "问题不能为空");

        com.supervision.qanything.dto.offline.ChatParam chatParam = new com.supervision.qanything.dto.offline.ChatParam();
        chatParam.setQuestion(question);
        chatParam.setKbIds(kbIds);
        chatParam.setUserId(defaultUserId);
        String paramString = JSONUtil.toJsonStr(chatParam.toMap());
        log.info("chat:请求参数：{}", paramString);
        HttpRequest request = HttpRequest.post(BASE_URL + "/api/local_doc_qa/local_doc_chat")
                .body(paramString);
        try (HttpResponse response = request.execute()){
            String body = response.body();
            log.info("chat:响应结果：{}", body);
            com.supervision.qanything.dto.offline.ChatResult offLineChatResult = JSONUtil.toBean(body, com.supervision.qanything.dto.offline.ChatResult.class);
            return offLineChatResult.toResultWrapper();
        }
    }

    @Override
    public ResultWrapper<ChatResult> chat(String question, List<HistoryDTO> history, List<String> kbIds) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public void chatStream(HttpServletResponse response, String question, List<String> kbIds) throws NoSuchAlgorithmException, IOException {

    }

    @Override
    public ResultWrapper<List<UploadResult>> uploadDoc(String kbId, File file) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<List<UploadResult>> uploadDoc(String kbId, String fileName, byte[] bytes) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<List<UploadResult>> uploadUrl(String kbId, String url) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<List<String>> deleteFile(String kbId, List<String> fileIds) throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<List<CreateKBResult>> kbList() throws NoSuchAlgorithmException {
        return null;
    }

    @Override
    public ResultWrapper<List<UploadResult>> fileList(String kbId) throws NoSuchAlgorithmException {
        return null;
    }
}
